<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Plugins Docs Source: data/data.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Plugins Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="modules.list.html" class="dropdown-toggle" data-toggle="dropdown">Modules<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-ableton_ableton.html">ableton/ableton</a></li><li><a href="module-control_control.html">control/control</a></li><li><a href="module-d-pro_d-pro.html">d-pro/d-pro</a></li><li><a href="module-data_data.html">data/data</a></li><li><a href="module-devices_device.html">devices/device</a></li><li><a href="module-devices_devices.html">devices/devices</a></li><li><a href="module-logic_logic.html">logic/logic</a></li><li><a href="module-messenger.html">messenger</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-sound_sound.html">sound/sound</a></li><li><a href="module-telegram_client.html">telegram/client</a></li><li><a href="module-telegram_telegram.html">telegram/telegram</a></li><li><a href="module-time_time.html">time/time</a></li><li><a href="module-tradfri_tradfri.html">tradfri/tradfri</a></li><li><a href="module-twilio_phone.html">twilio/phone</a></li><li><a href="module-twilio_twilio.html">twilio/twilio</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-ableton_ableton-Liveset.html">ableton/ableton~Liveset</a></li><li><a href="module-control_control-SessionControl.html">control/control~SessionControl</a></li><li><a href="module-d-pro_d-pro-Show.html">d-pro/d-pro~Show</a></li><li><a href="module-data_data-Data.html">data/data~Data</a></li><li><a href="module-data_data-CollectionAPI.html">data/data~CollectionAPI</a></li><li><a href="module-devices_device-Device.html">devices/device~Device</a></li><li><a href="module-devices_device-UDPdevice.html">devices/device~UDPdevice</a></li><li><a href="module-devices_device-OSCdevice.html">devices/device~OSCdevice</a></li><li><a href="module-devices_device-TCPdevice.html">devices/device~TCPdevice</a></li><li><a href="module-devices_device-Webdevice.html">devices/device~Webdevice</a></li><li><a href="module-devices_device-Serialdevice.html">devices/device~Serialdevice</a></li><li><a href="module-devices_device-Mididevice.html">devices/device~Mididevice</a></li><li><a href="module-logic_logic-Logic.html">logic/logic~Logic</a></li><li><a href="module-logic_logic-Condition.html">logic/logic~Condition</a></li><li><a href="module-logic_logic-Listener.html">logic/logic~Listener</a></li><li><a href="module-logic_logic-PEventListener.html">logic/logic~PEventListener</a></li><li><a href="module-messenger-Messenger.html">messenger~Messenger</a></li><li><a href="module-messenger-Conversation.html">messenger~Conversation</a></li><li><a href="module-messenger-Agent.html">messenger~Agent</a></li><li><a href="module-plugin-Plugin.html">plugin~Plugin</a></li><li><a href="module-plugin-Collection.html">plugin~Collection</a></li><li><a href="module-plugin-Item.html">plugin~Item</a></li><li><a href="module-telegram_client-Agent.html">telegram/client~Agent</a></li><li><a href="module-telegram_client-Client.html">telegram/client~Client</a></li><li><a href="module-telegram_client-Bot.html">telegram/client~Bot</a></li><li><a href="module-telegram_telegram-Telegram.html">telegram/telegram~Telegram</a></li><li><a href="module-telegram_telegram-Conversation.html">telegram/telegram~Conversation</a></li><li><a href="module-telegram_telegram-Dialogue.html">telegram/telegram~Dialogue</a></li><li><a href="module-telegram_telegram-DialogueCondition.html">telegram/telegram~DialogueCondition</a></li><li><a href="module-telegram_telegram-Chat.html">telegram/telegram~Chat</a></li><li><a href="module-telegram_telegram-Message.html">telegram/telegram~Message</a></li><li><a href="module-twilio_phone-Phone.html">twilio/phone~Phone</a></li><li><a href="module-twilio_twilio-Switchboard.html">twilio/twilio~Switchboard</a></li><li><a href="module-twilio_twilio-SmsIn.html">twilio/twilio~SmsIn</a></li><li><a href="module-twilio_twilio-Call.html">twilio/twilio~Call</a></li><li><a href="module-twilio_twilio-CallIn.html">twilio/twilio~CallIn</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: data/data.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
 * Organize access to plaiframe data collections
 * 
 * @requires plugin
 * @requires json5
 * @requires file
 * 
 * @module data/data
 * @copyright Lasse Marburg 2020
 * @license GPLv3
 */

const plugin = require('../plugin.js')
var schema = require('./schema.json')
const JSON5 = require('json5')
const file = require('../../file.js')


/**
* install request API for all custom collections the game contains
*/
class Data extends plugin.Plugin {
  constructor() {
    super(schema)
    this.name = "data"
    this.collection_apis = []
  }

  /**
  * create request API for each custom database
  * 
  * collect files in file directory and watch for changes.
  */
  setup(config) {
    return new Promise((resolve, reject) => {
      if (config.hasOwnProperty("custom_collections")) {
        if (config.custom_collections) {
          for (let collection of config.custom_collections) {
            if (!config.db.hasOwnProperty(collection)) {
              log.error(this.name, collection + " not found")
              break
            }
            this.collection_apis.push(new CollectionAPI(config.db[collection], config.app, config.game.name))
  
            if(config.db.type == "nedb") {
              this.schema.collections[collection] = {
                "type":"object",
                "properties":{
                  "telegram":{
                    "type":"object",
                    "options":{
                      "disable_edit_json":true,
                      "disable_properties":true,
                    },
                    "properties":{
                      "id":{
                        "type":"number",
                        "readOnly": true
                      },
                      "first_name":{
                        "type":"string",
                        "readOnly": true
                      },
                      "last_name":{
                        "type":"string",
                        "readOnly": true
                      },
                      "access_hash":{
                        "type":"string",
                        "readOnly": true
                      },
                      "phone":{
                        "type":"string",
                        "readOnly": true
                      },
                      "username":{
                        "anyOf":[{
                          "type":"string",
                          "readOnly": true
                        },{
                          "type":"null",
                          "readOnly": true
                        }]
                        
                      },
                      "initial":{
                        "type":"boolean",
                        "readOnly":true
                      }
                    }
                  },
                  "telegram_contacts":{
                    "type":"array",
                    "items":{
                      "type":"string"
                    }
                  }
                }
              }
            }
          }
        }
      }
      super.setup(config)
      .then(result => {
        log.debug(this.name, "load assets filenames from " + this.game.assets)
        file.mkdir(this.game.assets)

        this.collectFiles(this.game.assets)

        file.watchDir(this.game.assets, (e, file) => {
          this.collectFiles(this.game.assets)
          log.debug(this.name, "change in file directory: " + e + " " + file)
          this.schemaUpdate(this.schema)
        })
        
        return resolve(this.schema)
      })
      .catch(err => {
        return reject(err)
      })
    })
  }

  collectFiles(path) {
    this.schema.definitions.files.anyOf[0].enum = []

    let files = file.ls(path, ".")

    for(let f of files) {
      this.schema.definitions.files.anyOf[0].enum.push(f)
    }

    let dirs = file.ls(path, "directories")

    for(let dir of dirs) {
      let files = file.ls(path + "/" + dir, ".")
      for(let fi of files) {
        this.schema.definitions.files.anyOf[0].enum.push(dir + "/" + fi)
      }
    }
  }

  cue(data, session) {
    return new Promise((resolve, reject) => {
      for (let item in data) {
        switch (item) {
          case "store":
            this.store(data[item], session)
              .then(result => {
                return resolve(result) // always undefined
              })
              .catch(error => {
                return reject(error)
              })
            break
          case "load":
            this.load(data[item], session)
            .then(result => {
              return resolve(result) // always undefined
            })
            .catch(error => {
              return reject(error)
            })
        }   
      }
    })
  }

  store(properties, session) {
    return new Promise((resolve, reject) => {
      let name = session.name + " store"
      if (properties.hasOwnProperty("update")) {
        var ref = session.variables.getReference(properties.document)

        session.variables.review(properties.update)
          .then(result => {
            try {
              var update = JSON5.parse(result)
            } catch (err) {
              log.error(name, "couldn't store " + result + ". Not a valid JSON")
              throw new Error(err)
            }
            log.info(name, "Store " + result + " to " + ref.collection + " " + JSON.stringify(ref.query))
            return this.db[ref.collection].update(ref.query, update)
          })
          .then(res => {
            log.debug(name, " matched: " + res.matchedCount + ", modiified: " + res.modifiedCount)
            return resolve(undefined)
          })
          .catch(error => {
            log.error(name, error)
            return resolve(undefined)
          })
      } else if (properties.hasOwnProperty("set")) {
        var ref = session.variables.getReference(properties.document)
        var store_promises = []
        for (let key in properties.set) {
          store_promises.push(this.setValue(key, properties.set[key], ref, session))
        }
        Promise.all(store_promises)
          .then(result => {
            let modified = 0
            let matched = 0
            for (let res of result) {
              modified += res.modifiedCount
              matched += res.matchedCount
            }
            log.debug(name, "changed " + modified + " of " + matched + " entries")
            return resolve(undefined)
          })
          .catch(error => {
            log.error(this.name, error)
            return resolve(undefined)
          })
      } else {
        log.warn(name, "Properties missing store action")
        return resolve(undefined)
      }
    })
  }

  /**
   * create new reference to current session in an external document.
   * 
   * document can than be accessed during session through name reference.
   *
   * @param {Object} properties
   * @param {Object} session
   * @returns {Promise} - returns next cue (if any) once reference was created
   */
  load(properties, session) {
    return new Promise((resolve, reject) => {
      if(!Object.hasOwnProperties(properties, ["collection", "query", "name"])) {
        return reject("can not load reference. collection, query or name property missing.")
      }

      session.variables.review(properties.query)
      .then(result => {
        return session.createReference(properties["collection"], result, properties["name"])
      })
      .then(result => {
        if(properties.next) {
          return resolve(properties.next)
        }
        return resolve()
      })
      .catch(err => {
        return reject(err)
      })
    })
  }

  setValue(key, value, ref, session) {
    return new Promise((resolve, reject) => {
      session.variables.review(value)
        .then(result => {
          let update = {}
          update[key] = result
          return this.db[ref.collection].set(ref.query, update)
        })
        .then(res => {
          return resolve(res)
        })
        .catch(error => {
          log.error("set value", error)
          return resolve(undefined)
        })
    })
  }
}

/**
* creates express app routing to enable requests to interface with mongodb collection
* read only access on game url
* read/write access on secured /data subaddress
*
* allows [Cross-origin resource sharing](https://en.wikipedia.org/wiki/Cross-origin_resource_sharing)
*
* @param {Object} collection - mongodb collection interface
* @param {Object} app - express app as forwarded form index.js
* @param {string} game - game name to create game specific routing (/&lt;game>/&lt;collection>)
*/
class CollectionAPI {
  constructor(collection, app, game) {
    this.name = collection.name + "API"
    this.collection = collection
    
    if(collection.name != "player") {
      log.info(this.name, "Create API routing at /" + game + '/' + collection.name)
      app.get('/' + game + '/' + collection.name, this.incommingReadOnly.bind(this))
    }

    log.info(this.name, "Create API routing at /" + game + '/data/' + collection.name)
    app.get('/' + game + '/data/' + collection.name, this.incomming.bind(this))
    
  }

  incommingReadOnly(req, res) {
    this.incomming(req, res, "read")
  }

  /**
  * deal with requests
  */
  incomming(req, res, mode) {
    //log.info(this.name, req.headers.host)
    let prom
    if (!Object.isEmpty(req.body)) {
      log.info(this.name, req.body)
      prom = this.handle(req.body, mode)
    } else if (!Object.isEmpty(req.query)) {
      prom = this.handle(req.query, mode)
    } else {
      log.warn(this.name, "Request with no body or query data. Headers:")
      log.warn(this.name, req.headers)
      log.warn(this.name, req.query)
      log.warn(this.name, req.body)
      throw new Error("content missing")
    }
    prom.then(result => {
      res.status(200)
      res.send(result)
    })
    .catch(error => {
      res.status(400)
      res.send(error)
      log.warn(this.name, error)
    })
  }

  /**
  * Interface with mongo collection
  * 
  * get documents or update database
  * 
  * allows update with
  * $set (set), 
  * $push (push) 
  * or $pull (pull) operator
  *
  * @param {Object} data - request data from body or query
  */
  handle(data, mode) {
    return new Promise((resolve, reject) => {
      log.debug(this.name, data)
      if (data.hasOwnProperty("set") &amp;&amp; data.hasOwnProperty("key") &amp;&amp; mode != "read") {
        let query = {}
        query[data.key] = data.set
        delete data.set
        delete data.key

        for (let d in data) {
          if (data[d][0] == '{') {
            try {
              data[d] = JSON5.parse(data[d])
            } catch (err) {
              if (err instanceof SyntaxError) {
                log.warn(this.name, 'syntax error in query "' + data[d] + '"')
              } else {
                log.error(this.name, 'Error when parsing to json:')
                log.error(this.name, err)
              }
              return reject("error when parsing json: " + err.message)
            }
          }
        }

        return resolve(this.collection.set(query, data))
      } else if (data.hasOwnProperty("push") &amp;&amp; mode != "read") {
        let query = {}
        query[data.key] = data.push
        delete data.push
        delete data.key

        return resolve(this.collection.push(query, data))
      } else if (data.hasOwnProperty("pull")) {
        let query = {}
        query[data.key] = data.pull
        delete data.pull
        delete data.key

        return resolve(this.collection.remove(query, data))
      } else if (data.hasOwnProperty("get")) {
        var key = data.get
        delete data.get
        for(let d in data) {
          if(data[d] == "undefined") {
            data[d] = undefined
          }
        }
        this.collection.find(data)
          .then(result => {
            for (let res of result) {
              if (res.hasOwnProperty(key)) {
                return resolve(res[key])
              } else if (key == "all") {
                return resolve(res)
              } else {
                return reject("no such key: " + key)
              }
            }
            return reject("not found")
          })
      } else if (data.hasOwnProperty("getMany")) {
        var key = data.getMany
        delete data.getMany
        for(let d in data) {
          if(data[d] == "undefined") {
            data[d] = undefined
          }
        }
        this.collection.find(data)
          .then(result => {
            if (result.length) {
              let ret_val = []
              for (let res of result) {
                if (res.hasOwnProperty(key)) {
                  ret_val.push(res[key])
                } else if (key == "all") {
                  ret_val.push(res)
                } else {
                  ret_val.push(undefined)
                }
              }
              return resolve(ret_val)
            } else {
              return reject("not found")
            }
          })
      } else if(mode == "read") {
        return reject("no write access")
      } else {
        return reject("property missing")
      }
    })
  }
}

module.exports.Plugin = Data
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/webview/'>Webview Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
